// Code generated by go-swagger; DO NOT EDIT.

package application_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"io"
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/runtime/middleware"

	strfmt "github.com/go-openapi/strfmt"

	models "gitlab.com/kathra/kathra/kathra-services/kathra-runtimemanager/kathra-runtimemanager-go/kathra-runtimemanager-interface/models"
)

// NewAddApplicationToRuntimeEnvironmentParams creates a new AddApplicationToRuntimeEnvironmentParams object
// no default values defined in spec.
func NewAddApplicationToRuntimeEnvironmentParams() AddApplicationToRuntimeEnvironmentParams {

	return AddApplicationToRuntimeEnvironmentParams{}
}

// AddApplicationToRuntimeEnvironmentParams contains all the bound params for the add application to runtime environment operation
// typically these are obtained from a http.Request
//
// swagger:parameters addApplicationToRuntimeEnvironment
type AddApplicationToRuntimeEnvironmentParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*RuntimeAppInstance to deploy
	  Required: true
	  In: body
	*/
	RuntimeAppInstance *models.RuntimeAppInstance
	/*RuntimeEnvironment providerId
	  Required: true
	  In: path
	*/
	ProviderID string
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewAddApplicationToRuntimeEnvironmentParams() beforehand.
func (o *AddApplicationToRuntimeEnvironmentParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	if runtime.HasBody(r) {
		defer r.Body.Close()
		var body models.RuntimeAppInstance
		if err := route.Consumer.Consume(r.Body, &body); err != nil {
			if err == io.EOF {
				res = append(res, errors.Required("runtimeAppInstance", "body"))
			} else {
				res = append(res, errors.NewParseError("runtimeAppInstance", "body", "", err))
			}
		} else {
			// validate body object
			if err := body.Validate(route.Formats); err != nil {
				res = append(res, err)
			}

			if len(res) == 0 {
				o.RuntimeAppInstance = &body
			}
		}
	} else {
		res = append(res, errors.Required("runtimeAppInstance", "body"))
	}
	rProviderID, rhkProviderID, _ := route.Params.GetOK("providerId")
	if err := o.bindProviderID(rProviderID, rhkProviderID, route.Formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindProviderID binds and validates parameter ProviderID from path.
func (o *AddApplicationToRuntimeEnvironmentParams) bindProviderID(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route

	o.ProviderID = raw

	return nil
}
